﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Markup;
using System.IO;

namespace XamlReaderWriterDemo
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(Window1_Loaded);
        }

        void Window1_Loaded(object sender, RoutedEventArgs e)
        {
            //XamlReader  
            StringBuilder strXMAL = new StringBuilder("<Window ");
            strXMAL.Append("xmlns=\"http://schemas.microsoft.com/winfx/2006/xaml/presentation\" ");
            strXMAL.Append("xmlns:x=\"http://schemas.microsoft.com/winfx/2006/xaml\" ");
            strXMAL.Append("Title=\"Window2\" Height=\"600\" Width=\"600\">");
            strXMAL.Append("</Window>");
            var window = (Window)XamlReader.Parse(strXMAL.ToString());
            window.ShowDialog();

            //XamlReader  
            using (var stream = new FileStream(@"Window2.xaml", FileMode.Open))
            {
                var window2 = (Window)XamlReader.Load(stream);

                var button = (Button)window2.FindName("btnTest");
                button.Click += (x, y) => MessageBox.Show("Knights Warrior");

                window2.ShowDialog();
            }

            //XamlWriter
            var xaml = XamlWriter.Save(new Window2());
            MessageBox.Show(xaml);


            //System.Uri uri = new System.Uri(@"C:\Documents and Settings\Administrator\Desktop\XamlReaderWriterDemo\XamlReaderWriterDemo\bin\Debug\window2.xaml", System.UriKind.Absolute);
            //Window window3 = (Window)Application.LoadComponent(uri);    

        }
    }
}
